## uvch264src

uvch264src

## Properties

guint | average-bitrate | Read / Write
gchar * | colorspace-name | Read / Write / Construct
gchar * | device | Read / Write
gchar * | device-name | Read
gboolean | enable-sei | Read / Write
UvcH264Entropy | entropy | Read / Write
gboolean | fixed-framerate | Read / Write
guint | iframe-period | Read / Write
guint | initial-bitrate | Read / Write
gchar * | jpeg-decoder-name | Read / Write / Construct
guint | leaky-bucket-size | Read / Write
guint | level-idc | Read / Write
gint | ltr-buffer-size | Read / Write
gint | ltr-encoder-control | Read / Write
gint | max-bframe-qp | Read / Write
gint | max-iframe-qp | Read / Write
guint | max-mbps | Read
gint | max-pframe-qp | Read / Write
gint | min-bframe-qp | Read / Write
gint | min-iframe-qp | Read / Write
gint | min-pframe-qp | Read / Write
gint | num-buffers | Read / Write
gint | num-clock-samples | Read / Write / Construct
guint | num-reorder-frames | Read / Write
guint | peak-bitrate | Read / Write
gboolean | preview-flipped | Read / Write
UvcH264RateControl | rate-control | Read / Write
UvcH264SliceMode | slice-mode | Read / Write
guint | slice-units | Read / Write
UvcH264UsageType | usage-type | Read / Write

## Signals

gboolean | get-boolean-setting | Action
gboolean | get-enum-setting | Action
gboolean | get-int-setting | Action

## Types and Values

struct | GstUvcH264Src

## Object Hierarchy

        GObject
        ╰── GInitiallyUnowned
            ╰── GstObject
                ╰── GstElement
                    ╰── GstBin
                        ╰── GstBaseCameraSrc
                            ╰── GstUvcH264Src

## Implemented Interfaces

GstUvcH264Src implements GstChildProxy.

## Description

## Synopsis

### Element Information

plugin | uvch264
author | Youness Alaoui <youness.alaoui@collabora.co.uk>
class | Source/Video

### Element Pads

name | imgsrc
direction | source
presence | always
details | EMPTY

name | vfsrc
direction | source
presence | always

details

video/x-raw, format=(string){ I420, YV12, YUY2, UYVY, AYUV, VUYA, RGBx, BGRx, xRGB, xBGR, RGBA, BGRA, ARGB, ABGR, RGB, BGR, Y41B, Y42B, YVYU, Y444, v210, v216, Y210, Y410, NV12, NV21, GRAY8, GRAY16_BE, GRAY16_LE, v308, RGB16, BGR16, RGB15, BGR15, UYVP, A420, RGB8P, YUV9, YVU9, IYU1, ARGB64, AYUV64, r210, I420_10BE, I420_10LE, I422_10BE, I422_10LE, Y444_10BE, Y444_10LE, GBR, GBR_10BE, GBR_10LE, NV16, NV24, NV12_64Z32, A420_10BE, A420_10LE, A422_10BE, A422_10LE, A444_10BE, A444_10LE, NV61, P010_10BE, P010_10LE, IYU2, VYUY, GBRA, GBRA_10BE, GBRA_10LE, BGR10A2_LE, GBR_12BE, GBR_12LE, GBRA_12BE, GBRA_12LE, I420_12BE, I420_12LE, I422_12BE, I422_12LE, Y444_12BE, Y444_12LE, GRAY10_LE32, NV12_10LE32, NV16_10LE32, NV12_10LE40 }, width=(int)[ 1, 2147483647 ], height=(int)[ 1, 2147483647 ], framerate=(fraction)[ 0/1, 2147483647/1 ]

| image/jpeg, width=(int)[ 1, 2147483647 ], height=(int)[ 1, 2147483647 ], framerate=(fraction)[ 0/1, 2147483647/1 ]

name | vidsrc
direction | source
presence | always

details

video/x-raw, format=(string){ I420, YV12, YUY2, UYVY, AYUV, VUYA, RGBx, BGRx, xRGB, xBGR, RGBA, BGRA, ARGB, ABGR, RGB, BGR, Y41B, Y42B, YVYU, Y444, v210, v216, Y210, Y410, NV12, NV21, GRAY8, GRAY16_BE, GRAY16_LE, v308, RGB16, BGR16, RGB15, BGR15, UYVP, A420, RGB8P, YUV9, YVU9, IYU1, ARGB64, AYUV64, r210, I420_10BE, I420_10LE, I422_10BE, I422_10LE, Y444_10BE, Y444_10LE, GBR, GBR_10BE, GBR_10LE, NV16, NV24, NV12_64Z32, A420_10BE, A420_10LE, A422_10BE, A422_10LE, A444_10BE, A444_10LE, NV61, P010_10BE, P010_10LE, IYU2, VYUY, GBRA, GBRA_10BE, GBRA_10LE, BGR10A2_LE, GBR_12BE, GBR_12LE, GBRA_12BE, GBRA_12LE, I420_12BE, I420_12LE, I422_12BE, I422_12LE, Y444_12BE, Y444_12LE, GRAY10_LE32, NV12_10LE32, NV16_10LE32, NV12_10LE40 }, width=(int)[ 1, 2147483647 ], height=(int)[ 1, 2147483647 ], framerate=(fraction)[ 0/1, 2147483647/1 ]

| image/jpeg, width=(int)[ 1, 2147483647 ], height=(int)[ 1, 2147483647 ], framerate=(fraction)[ 0/1, 2147483647/1 ]
| video/x-h264, width=(int)[ 1, 2147483647 ], height=(int)[ 1, 2147483647 ], framerate=(fraction)[ 0/1, 2147483647/1 ], stream-format=(string){ byte-stream, avc }, alignment=(string)au, profile=(string){ high, main, baseline, constrained-baseline }

## Functions

## Types and Values

### struct GstUvcH264Src

    struct GstUvcH264Src;

## Property Details

### The `“average-bitrate”` property

      “average-bitrate”          guint

The average bitrate in bits/second (dynamic control).

Flags: Read / Write

Default value: 3000000

### The `“colorspace-name”` property

      “colorspace-name”          gchar *

The name of the colorspace element.

Flags: Read / Write / Construct

Default value: "videoconvert"

### The `“device”` property

      “device”                   gchar *

Device location.

Flags: Read / Write

Default value: "/dev/video0"

### The `“device-name”` property

      “device-name”              gchar *

Name of the device.

Flags: Read

Default value: NULL

### The `“enable-sei”` property

      “enable-sei”               gboolean

Enable SEI picture timing (static control).

Flags: Read / Write

Default value: FALSE

### The `“entropy”` property

      “entropy”                  UvcH264Entropy

Entropy (static control).

Flags: Read / Write

Default value: CAVLC

### The `“fixed-framerate”` property

      “fixed-framerate”          gboolean

Fixed framerate (static & dynamic control).

Flags: Read / Write

Default value: FALSE

### The `“iframe-period”` property

      “iframe-period”            guint

Time between IDR frames in milliseconds (static control).

Flags: Read / Write

Allowed values: <= 65535

Default value: 10000

### The `“initial-bitrate”` property

      “initial-bitrate”          guint

Initial bitrate in bits/second (static control).

Flags: Read / Write

Default value: 3000000

### The `“jpeg-decoder-name”` property

      “jpeg-decoder-name”        gchar *

The name of the jpeg decoder element.

Flags: Read / Write / Construct

Default value: "jpegdec"

### The `“leaky-bucket-size”` property

      “leaky-bucket-size”        guint

Size of the leaky bucket size in milliseconds (static control).

Flags: Read / Write

Allowed values: <= 65535

Default value: 1000

### The `“level-idc”` property

      “level-idc”                guint

Level IDC (dynamic control).

Flags: Read / Write

Allowed values: <= 255

Default value: 40

### The `“ltr-buffer-size”` property

      “ltr-buffer-size”          gint

Total number of Long-Term Reference frames (dynamic control).

Flags: Read / Write

Allowed values: [0,255]

Default value: 0

### The `“ltr-encoder-control”` property

      “ltr-encoder-control”      gint

Number of LTR frames the device can control (dynamic control).

Flags: Read / Write

Allowed values: [0,255]

Default value: 0

### The `“max-bframe-qp”` property

      “max-bframe-qp”            gint

The minimum Quantization step size for B frames (dynamic control).

Flags: Read / Write

Allowed values: [-127,127]

Default value: 46

### The `“max-iframe-qp”` property

      “max-iframe-qp”            gint

The minimum Quantization step size for I frames (dynamic control).

Flags: Read / Write

Allowed values: [-127,127]

Default value: 46

### The `“max-mbps”` property

      “max-mbps”                 guint

The number of macroblocks per second for the maximum processing rate.

Flags: Read

Default value: 0

### The `“max-pframe-qp”` property

      “max-pframe-qp”            gint

The minimum Quantization step size for P frames (dynamic control).

Flags: Read / Write

Allowed values: [-127,127]

Default value: 46

### The `“min-bframe-qp”` property

      “min-bframe-qp”            gint

The minimum Quantization step size for B frames (dynamic control).

Flags: Read / Write

Allowed values: [-127,127]

Default value: 10

### The `“min-iframe-qp”` property

      “min-iframe-qp”            gint

The minimum Quantization step size for I frames (dynamic control).

Flags: Read / Write

Allowed values: [-127,127]

Default value: 10

### The `“min-pframe-qp”` property

      “min-pframe-qp”            gint

The minimum Quantization step size for P frames (dynamic control).

Flags: Read / Write

Allowed values: [-127,127]

Default value: 10

### The `“num-buffers”` property

      “num-buffers”              gint

Number of buffers to output before sending EOS (-1 = unlimited).

Flags: Read / Write

Allowed values: >= G_MAXULONG

Default value: -1

### The `“num-clock-samples”` property

      “num-clock-samples”        gint

Number of clock samples to gather for the PTS synchronization (-1 = unlimited).

Flags: Read / Write / Construct

Allowed values: >= 0

Default value: 0

### The `“num-reorder-frames”` property

      “num-reorder-frames”       guint

Number of B frames between the references frames (static control).

Flags: Read / Write

Allowed values: <= 255

Default value: 0

### The `“peak-bitrate”` property

      “peak-bitrate”             guint

The peak bitrate in bits/second (dynamic control).

Flags: Read / Write

Default value: 3000000

### The `“preview-flipped”` property

      “preview-flipped”          gboolean

Horizontal flipped image for non H.264 streams (static control).

Flags: Read / Write

Default value: FALSE

### The `“rate-control”` property

      “rate-control”             UvcH264RateControl

Rate control mode (static & dynamic control).

Flags: Read / Write

Default value: Constant bit rate

### The `“slice-mode”` property

      “slice-mode”               UvcH264SliceMode

Defines the unit of the slice-units property (static control).

Flags: Read / Write

Default value: Slice Per Frame

### The `“slice-units”` property

      “slice-units”              guint

Slice units (static control).

Flags: Read / Write

Allowed values: <= 65535

Default value: 4

### The `“usage-type”` property

      “usage-type”               UvcH264UsageType

The usage type (static control).

Flags: Read / Write

Default value: Realtime (video conferencing)

## Signal Details

### The `“get-boolean-setting”` signal

    gboolean
    user_function (GstUvcH264Src *gstuvch264src,
                   gchar         *arg1,
                   gpointer       arg2,
                   gpointer       arg3,
                   gpointer       user_data)

Flags: Action

### The `“get-enum-setting”` signal

    gboolean
    user_function (GstUvcH264Src *gstuvch264src,
                   gchar         *arg1,
                   gpointer       arg2,
                   gpointer       arg3,
                   gpointer       user_data)

Flags: Action

### The `“get-int-setting”` signal

    gboolean
    user_function (GstUvcH264Src *gstuvch264src,
                   gchar         *arg1,
                   gpointer       arg2,
                   gpointer       arg3,
                   gpointer       arg4,
                   gpointer       user_data)

Flags: Action